;****************************************************************************
;*
;*	file view, text/hex - created 1997 by future vision
;*
;*	tasm compatible source code
;*
;****************************************************************************


win_lines	EQU	47
window_pos	EQU	(47-win_lines)*160


.386

main_seg		SEGMENT	USE16
	ASSUME	CS:main_seg
	ASSUME	DS:main_seg
	ORG	100h

com_entry:	jmp	start_up
	ORG	103h
		DB	'UILM'			;sign
		DW	offset low_mem_end-100h	;low memory size
		DD	0			;no xms
		DD	0
		DW	000001111111b		;menu,internal,external
;			  ^8  ^4  ^0
		DB	0			;no def internal hotkey
		DW	0			;no def external hotkey
		DW	0
		DB	'File view',0		;name
;****************************************************************************

start_up		PROC	NEAR
	LOCALS
		push		edi
		push		si
		push		ds
		mov		ah,0
		int		32h
		pop		es
		pop		si
		pop		edi
		push		cs
		pop		ds
		
		cmp		ax,'IS'
		jne	dos_call
		test		cl,100b		;uilm execution
		jz	dos_call

		mov		ax,es:[si+0ch]	;setup datbuffer adr
		mov		dat_table_seg,es
		mov		dat_table_ofs,ax
		mov		return_code,20h
		
		test		cl,10b
		jnz	@@fin_prog		;hotkey call?

		mov		ah,02h		;then full_entry
		int		32h
		inc		return_code	;=21h=immed_ret

@@fin_prog:	push		bp		;generate stackframe
		mov		bp,sp

		cmp		file_name,'*'
		jne	@@file_ok
get_file:	mov		shift_set,0	;get file name if none
		mov		ah,2ch
		push		ds
		pop		es
		mov		si,offset file_name
		mov		di,si
		mov		al,0
		mov		cx,-1
		repne scasb
		not		cx
		std
		mov		byte ptr ds:[di],0
		mov		al,'\'
		repne scasb
		cld
		jne	@@no_bs
		mov		dword ptr ds:[di+2],'*.*'
@@no_bs:	int		32h
		jc	return
		push		es
		pop		ds
		push		cs
		pop		es
		mov		di,offset file_name
		mov		cx,80
		rep movsb
		push		cs
		pop		ds
		mov		file_pos,0

@@file_ok:	mov		ax,3d00h	;open file
		mov		dx,offset file_name
		int		21h
		jnc	@@cont
		mov		dword ptr file_name,'*.*'
		jmp	abort

@@cont:		mov		bx,ax
		mov		ax,4202h	;seek to end, get file size
		xor		cx,cx
		mov		dx,cx
		int		21h
		jc	file_error
		mov		word ptr file_length_lo,ax
		mov		word ptr file_length_hi,dx
		call	show_win		;draw win

redraw:		push		bx
		mov		ah,23h		;decimal num output
		mov		bx,0a03h
		int		32h
		mov		bx,window_pos+(80-3-4)*2;pos
		mov		ah,21h
		int		32h
		mov		ah,20h		;color
		mov		bl,1eh
		int		32h
		xor		edx,edx		;calc and output
		imul		eax,file_pos,100
		mov		ebx,file_length
		or		ebx,ebx
		jnz	@@div_
		mov		eax,100
		jmp	@@set
@@div_:		div		ebx
@@set:		mov		ebx,eax
		mov		ah,24h
		int		32h
		pop		bx
		
		cmp		mode,0
		jne	hex_mode
		jmp	text_mode
start_up		ENDP
text_mode		PROC	NEAR
	LOCALS
;text mode
		mov		eax,file_pos
		mov		cfile_pos,eax
		mov		di,window_pos+160
		mov		cx,win_lines

@@text_loop:	push		cx		;lines to go
		push		di		;cursor pos
		push		di
		mov		al,' '
		call	write_line
		pop		di
		
		mov		ax,4200h	;seek to current pos
		mov		dx,cfile_pos_lo
		mov		cx,cfile_pos_hi
		int		21h
		jc	file_error
		mov		ah,2ah
		mov		cx,200h
		int		32h
		jc	return			;error msg allready shown
		mov		pos_add,ax
		or		ax,ax
		jz	@@eof

		push		di		;save cursor_pos
		mov		di,si
		movzx		eax,ax
		add		cfile_pos,eax
@@length_ok:	mov		ecx,eax
		mov		al,0ah
		repne scasb
;		mov		byte ptr es:[di-1],0
		pop		di
		sub		cfile_pos,ecx
		mov		end_char,0ah

		movzx		ax,shift_set
		shl		ax,1
		mov		shift,ax
		push		es
		pop		ds
		call	write_string
		push		cs
		pop		ds
		
		
@@eof:		pop		di		;cursor pos
		add		di,160
		pop		cx		;lines to go
		cmp		cl,win_lines
		jne	@@not_first_line
		mov		eax,cfile_pos
		mov		follow_pos,eax
@@not_first_line:		
		loop	@@text_loop
		

@@input_loop:	mov		ah,0
		int		16h
		cmp		al,27		;esc
		je	return
		cmp		al,'n'
		jne	@@no_search_next
		push		ds
		pop		es
		mov		eax,follow_pos
		mov		file_pos,eax
		mov		si,offset search_buffer
		jmp	@@search_next
@@no_search_next:		
		cmp		al,'s'
		jne	@@no_search
		mov		di,8*160
		mov		al,''
		call	write_line
		mov		al,' '
		call	write_line
		mov		al,''
		call	write_line
		mov		ah,27h		;get string
		push		ds
		pop		es
		mov		si,offset search_buffer
		int		32h
		jc	redraw
@@search_next:	mov		di,si
		mov		al,0
		mov		cx,-1
		repne scasb
		not		cx
		dec		cx
		jz	redraw
		mov		search_length,cx
		call	upcase
		mov		dx,file_pos_lo	;seek to current pos
		mov		cx,file_pos_hi
		mov		al,0
@@seek_back:	mov		ah,42h
		int		21h
		jc	file_error
@@cont_search:	mov		ah,2ah		;read
		mov		cx,200h
		int		32h
		jc	return			;error msg allready shown
		or		ax,ax
		jz	redraw			;eof
		mov		cx,ax
		
		mov		di,search_idx
		cmp		di,10*160-2
		jb	@@idx_ok
		mov		di,9*160
@@idx_ok:	mov		al,' '
		mov		color,1eh
		call	write_char
		mov		search_idx,di
		mov		al,''
		call	write_char
		mov		color,17h
		
		call	upcase
	;es:di
		mov		al,search_buffer
@@search:	repne scasb
		jne	@@cont_search
		cmp		cx,search_length
		jae	@@search_length
		mov		dx,-30h
		mov		cx,-1
		mov		al,1
		jmp	@@seek_back

@@search_length:push		di
		push		cx
		mov		si,offset search_buffer+1
		mov		cx,search_length
		dec		cx
		jz	@@found_
		repe cmpsb
@@found_:	pop		cx
		pop		di
		jne	@@search
		movzx		esi,cx
		mov		ax,4201h
		xor		cx,cx
		mov		dx,cx
		int		21h
		jc	file_error
		mov		file_pos_lo,ax
		mov		file_pos_hi,dx
		sub		file_pos,esi
		jmp	@@up
@@no_search:
		cmp		ah,61		;f3
		jne	@@no_file
other_file:	mov		ah,3eh		;close first
		int		21h
		jmp	get_file
@@no_file:	cmp		ah,64		;f6
		jne	@@no_f6
		mov		mode,1
		jmp	redraw
@@no_f6:
		cmp		ah,77		;right
		jne	@@no_right
@@right:	inc		shift_set
		jmp	redraw
@@no_right:	cmp		ah,75		;left
		jne	@@no_left
		dec		shift_set
		js	@@right
		jmp	redraw
@@no_left:	cmp		ah,64
		jne	@@no_hex_view
		mov		mode,1
		jmp	redraw
@@no_hex_view:
		cmp		ah,71		;home
		jne	@@no_home
		cmp		shift_set,0
		mov		shift_set,0
		jne	redraw
		mov		file_pos,0
		jmp	redraw
@@no_home:	cmp		ah,79		;end
		jne	@@no_end
		mov		eax,file_length
		mov		file_pos,eax
		jmp	@@last_scr
@@no_end:	cmp		ah,72		;up
		jne	@@no_up
@@up:		call	go_last_line
		jmp	redraw
@@no_up:	cmp		ah,73		;page up
		jne	@@no_page_up
@@last_scr:	mov		cx,win_lines
@@go_back:	call	go_last_line
		loop	@@go_back
		jmp	redraw
@@no_page_up:	cmp		pos_add,0	;no more down
		je	@@input_loop

		cmp		ah,80		;down
		jne	@@no_down
		mov		eax,follow_pos
		mov		file_pos,eax
		jmp	redraw
@@no_down:	cmp		ah,81		;pg down
		jne	@@no_pgdown
		mov		eax,cfile_pos
		mov		file_pos,eax
		jmp	redraw
@@no_pgdown:
		jmp	@@input_loop
		
		
		
text_mode		ENDP		

upcase			PROC	NEAR
	LOCALS
	;cx bytes at es:si
	;>es:di buffer
	;>ds=cs
		push		cx
		push		si
		push		es
		pop		ds
		mov		di,si
@@upcase:	lodsb
		cmp		al,'a'
		jb	@@no_upcase
		cmp		al,'z'
		ja	@@no_upcase
		sub		al,'a'-'A'
@@no_upcase:	stosb
		loop	@@upcase
		push		cs
		pop		ds
		pop		di
		pop		cx
		ret
upcase			ENDP


go_last_line		PROC	NEAR
	LOCALS
	;one line back
		push		cx
		mov		ecx,file_pos
		jecxz	@@done
		cmp		ecx,200h
		jbe	@@in_range
		mov		ecx,200h	;max 200 bytes
@@in_range:	sub		file_pos,ecx
		push		cx
		
		mov		ax,4200h	;seek to lower pos
		mov		dx,file_pos_lo
		mov		cx,file_pos_hi
		int		21h
		jc	file_error
		pop		cx		;read num of bytes
		mov		ah,2ah
		int		32h
		jc	return			;error msg allready shown
		movzx		ecx,ax
		mov		di,ax
		add		di,si
		dec		di
		dec		di
		dec		cx
		jcxz	@@done
		dec		cx
		jcxz	@@done
		std
		mov		al,0ah
		repne scasb
		cld
		jnz	@@done
		inc		cx
		inc		cx
		add		file_pos,ecx
@@done:		pop		cx
		ret
go_last_line		ENDP

hex_mode		PROC	NEAR
	LOCALS
;tex mode
		mov		eax,file_pos
		mov		cfile_pos,eax

		mov		ax,4200h	;seek to current pos
		mov		dx,file_pos_lo
		mov		cx,file_pos_hi
		int		21h
		jc	file_error

		mov		di,window_pos+160
		mov		cx,win_lines

@@hex_loop:	push		cx		;lines to go
		push		di		;cursor pos
		push		di
		mov		al,' '
		call	write_line
		pop		di
		scasd			;add di,4 (two bytes)
		
		mov		ah,2ah		;read 16 bytes
		mov		cx,16
		int		32h
		jc	return			;error msg allready shown
		mov		pos_add,ax
		movzx		ecx,ax
		jcxz	@@eof

		mov		eax,cfile_pos	;file offset
		call	write_dword
		scasd			;add di,4 (two bytes)

		add		cfile_pos,ecx
		push		di
		push		si
		push		cx
		push		es
		pop		ds		;ds:si buffer
@@out_hex:	lodsb
		call	write_byte		;hex bytes
		loop	@@out_hex
		pop		cx
		pop		si
		pop		di
		add		di,100
@@out_ascii:	lodsb
		call	write_char		;ascii out
		loop	@@out_ascii
@@eof:		push		cs
		pop		ds
		pop		di
		add		di,160
		pop		cx
		loop	@@hex_loop

@@input_loop:	mov		ah,0		;keybord commands
		int		16h
		cmp		ah,63
		jne	@@no_f5
		mov		mode,0
		jmp	redraw
@@no_f5:	cmp		ah,71		;home
		je	@@home
		cmp		ah,79		;end
		jne	@@no_end
		mov		eax,file_length
		and		al,0f0h
		sub		eax,(win_lines-1)*10h
		mov		file_pos,eax
		jmp	@@underflow
		
@@no_end:	cmp		al,1bh		;esc
		je	return
		cmp		ah,61		;f3
		je	other_file
		cmp		ah,75		;left
		jne	@@no_left
		dec		file_pos
@@underflow:	jns	redraw
@@home:		mov		file_pos,0
		jmp	redraw
@@no_left:	cmp		ah,72		;up
		jne	@@no_up
		sub		file_pos,10h
		jmp	@@underflow
@@no_up:	cmp		ah,73		;page up
		jne	@@no_page_up
		sub		file_pos,win_lines*10h
		jmp	@@underflow
@@no_page_up:
		cmp		pos_add,0
		je	@@input_loop
		cmp		ah,77		;right
		jne	@@no_right
		inc		file_pos
		jmp	redraw
@@no_right:	cmp		ah,80		;down
		jne	@@no_down
		add		file_pos,10h
		jmp	redraw
@@no_down:	cmp		ah,81		;page_down
		jne	@@input_loop
		add		file_pos,win_lines*10h
		jmp	redraw
		
hex_mode		ENDP

write_dword		PROC	NEAR		;writes dword hex num
		push		bx
		mov		bl,8
		jmp	write_num
write_byte		PROC	NEAR		;writes byte hex num
		push		bx
		mov		bl,2
write_num:	push		eax
		mov		ah,23h		;output format
		mov		bh,10h
		movzx		dx,bl
		int		32h
		mov		ah,21h		;cursor_pos
		mov		bx,di
		int		32h
		lea		edi,[edi+edx*2+2]	;new cursor pos
		mov		ah,20h		;color
		mov		bl,17h
		int		32h
		mov		ah,24h		;number output
		pop		ebx
		int		32h
		pop		bx
		ret
write_byte		ENDP
write_dword		ENDP

file_error		PROC	NEAR
		mov		ah,2dh		;show error msg
		int		32h

return:		mov		ah,3eh		;close file
		int		21h
abort:		leave
		mov		al,return_code
		retf				;and ret
file_error		ENDP

show_win		PROC	NEAR
;draws window
	LOCALS
		mov		di,window_pos
		mov		color,1fh
		mov		al,''
		call	write_line
		mov		cx,win_lines
@@win_loop:	mov		al,' '
		call	write_line
		loop	@@win_loop
		mov		al,''
		call	write_line
		mov		color,74h
		push		di
		mov		al,' '
		call	write_line
		pop		di
		mov		si,offset $help_line
		call	write_string
		mov		color,1eh
		mov		si,offset file_name-1
		mov		di,window_pos+2
		call	write_string
		mov		al,' '
		call	write_char
		mov		di,window_pos+(80-4-4)*2
		mov		si,offset $percent
		call	write_string

		mov		color,17h
		ret
show_win		ENDP
write_char		PROC	NEAR
	;al to di unsing color
		push		ax
		push		es
		mov		ah,cs:color
		push		0b800h
		pop		es
		stosw
		pop		es
		pop		ax
		ret
write_char		ENDP
write_line		PROC	NEAR
	LOCALS
	;al to di 80 times
		push		cx
		mov		cx,80
@@line_loop:	call	write_char
		loop	@@line_loop
		pop		cx
		ret
write_line		ENDP
write_string		PROC	NEAR
	LOCALS
	;di	display ofs
	;es:si	string_z, 09-tab, 0d-ignored
		push		ax
		push		bx
		push		dx
		mov		ax,di		;start next line into dx
		mov		dl,160
		div		dl
		inc		al
		mul		dl
		mov		dx,ax
		mov		bx,di
		sub		di,cs:shift	;skip first shift char
@@loop_string:	cmp		dx,di		;eol
		je	@@end_string
		lodsb
		cmp		al,cs:end_char	;0a or 00
		je	@@end_string
		cmp		al,0dh		;ignore cr
		je	@@loop_string
		cmp		al,09h		;tab
		jne	@@write_string
		add		di,cs:shift
		shr		di,4
		inc		di
		shl		di,4		;(cpos/16+1)*16
		sub		di,cs:shift
		jmp	@@loop_string
@@write_string:	cmp		di,bx
		jb	@@below_scr
		call	write_char
		jmp	@@loop_string
@@end_string:	pop		dx
		pop		bx
		pop		ax
		mov		cs:shift,0
		mov		cs:end_char,0
		ret
@@below_scr:	scasw			;add di,2  (one byte opc)
		jmp	@@loop_string
write_string		ENDP

return_code	DB	?
dat_table	LABEL	DWORD
dat_table_ofs	DW	?
dat_table_seg	DW	?
color		DB	?

		DB	' '
file_name	DB	'*.*',80 DUP(0)

pos_add		DW	?

file_pos	LABEL	DWORD
file_pos_lo	DW	?
file_pos_hi	DW	?

cfile_pos	LABEL	DWORD
cfile_pos_lo	DW	?
cfile_pos_hi	DW	?

follow_pos	DD	?

file_length	LABEL	DWORD
file_length_lo	DW	?
file_length_hi	DW	?

mode		DB	0

search_length	DW	?
search_buffer	DB	30h DUP(?)

shift		DW	0
shift_set	DB	0

end_char	DB	0

search_idx	DW	9*160

$help_line	DB	' ESC-Exit F3-Open S-Search N-Next  F5-Text F6-Hex',0
$percent	DB	' 100% ',0

low_mem_end		LABEL	WORD

dos_call		PROC	NEAR
		mov		dx,offset $no_dos
		mov		ah,9h
		int		21h
		mov		ax,4c00h
		int		21h
dos_call		ENDP
$no_dos		DB	'INTRUDER, file view uilm by FUTURE VISION',13,10
		DB	'...this is an user interface loadable module and can '
		DB	'not be executed by dos',13,10,'$'
main_seg		ENDS
			END	com_entry
